package climatiseur;

import java.util.HashMap;
import java.util.Timer;

public class Climatiseur {
    private int vitesse;
    private int tempConsigne;

    private EtatClimatiseur etatCourant;
    private HashMap<StateName, EtatClimatiseur> etats=new HashMap<>();

    private Timer timer;

    public Climatiseur(){
        etatCourant=new Eteint(this); // état initial
        vitesse =1;
        tempConsigne=21;
        etats.put(StateName.ReglageTimer, new ReglageTimer(this));
        etats.put(StateName.Accueil, new Accueil(this));
        etats.put(StateName.ReglageVitesse, new ReglageVitesse(this));
        etats.put(StateName.Eteint, new Eteint(this));
    }

    private void setState(EtatClimatiseur etat){
        this.etatCourant=etat;
    }

    private EtatClimatiseur getEtat(StateName nom) {
        return etats.get(nom); // TODO lever une exception si nom pas dans etats.keys
    }

    void transiterVers(StateName nomEtat){
        setState(getEtat(nomEtat));
    }

    public String toString(){
        return "Etat courant :"+etatCourant.getClass().getSimpleName()+" vitesse="+vitesse+" temp consigne="+tempConsigne;
    }

    // manipulations timer
    void ajoutTimerExtinction(int nbH){
        timer=new Timer(false);
        ExtinctionTask tt=new ExtinctionTask(this);
        //timer.schedule(tt, nbH*3600*1000);
        timer.schedule(tt, nbH*1000); // pour tester on utilise des secondes et pas des heures
    }

    void desarmerTimer(){
        if (timer!=null) {timer.cancel();timer.purge();}
    }
    // manipulation vitesse et tempConseigne
     void incrTemp(){
        if (tempConsigne<30){
            tempConsigne++;
        }
    }

     void decrTemp(){
        if (tempConsigne>15){
            tempConsigne--;
        }
    }

     void incrVitesse(){
        if (vitesse<5){
            vitesse++;
        }
    }



     void decrVitesse(){
        if (vitesse>1){
            vitesse--;
        }
    }

    //
     void allumer(){
        System.out.println("allumage du climatiseur");
    }

     void eteindre(){
        desarmerTimer();
        System.out.println("extinction du climatiseur");
    }

    // messages qui dépendent de l'état
    public void onOff(){
        etatCourant.onOff();
    }
    public void timer(){etatCourant.timer();};
    public void plus(){etatCourant.plus();};
    public void minus(){etatCourant.minus();};
    public void airflow(){etatCourant.airflow();};


}
